let start;
let enb_a = enb_b = enb_x = enb_y = true;
let enb_lb = enb_lt = enb_rb = enb_rt = enb_lsb = enb_rsb = true;
let enb_u = enb_ru = enb_r = enb_rd = enb_d = enb_ld = enb_l = enb_lu = true;
let c_past = '';
let s_past = '';
let dbl = '';
let on_count = 0;

// 方向プッシュ中かどうか
let pushed_arr = false;
let loopCount = 0;

// 同時タイミング
let dj = 10;


// ファイティング
let fighting = false;
$(function () {
  if($('body').attr('data-type') == 'key_display_fighting') {
    fighting = true;
  }
});


// btnPressed
const btnPressed = (button) => {
  if (typeof button == "object") {
    return button.pressed;
  }
  return button == 1.0;
};


// padMonitor
const padMonitor = () => {

  const gamepads = navigator.getGamepads
    ? navigator.getGamepads()
    : navigator.webkitGetGamepads
    ? navigator.webkitGetGamepads
    : [];
  if (!gamepads) {
    return;
  }

  const gp = gamepads[0];


  // 上ボタン
  var cs_u = false;
  if (btnPressed(gp.buttons[12])) {
    cs_u = true;
  } else {
    cs_u = false;
  }
  // 下ボタン
  var cs_d = false;
  if (btnPressed(gp.buttons[13])) {
    cs_d = true;
  } else {
    cs_d = false;
  }
  // 左ボタン
  var cs_l = false;
  if (btnPressed(gp.buttons[14])) {
    cs_l = true;
  } else {
    cs_l = false;
  }
  // 右ボタン
  var cs_r = false;
  if (btnPressed(gp.buttons[15])) {
    cs_r = true;
  } else {
    cs_r = false;
  }


  if(!cs_u && !cs_r && !cs_d && !cs_l) {
    c_past = '';
  }

  if(cs_u && !cs_r && !cs_l) {
    if(c_past != 'u') {
      $('#gamepad .material .crs_u').clone(true).prependTo('#gamepad .active');
      c_past = 'u';
    }
  }
  if(cs_u && cs_r && !cs_l) {
    if(c_past != 'ru') {
      $('#gamepad .material .crs_ru').clone(true).prependTo('#gamepad .active');
      c_past = 'ru';
    }
  }
  if(cs_u && !cs_r && cs_l) {
    if(c_past != 'lu') {
      $('#gamepad .material .crs_lu').clone(true).prependTo('#gamepad .active');
      c_past = 'lu';
    }
  }

  if(cs_r && !cs_u && !cs_d) {
    if(c_past != 'r') {
      $('#gamepad .material .crs_r').clone(true).prependTo('#gamepad .active');
      c_past = 'r';
    }
  }

  if(cs_d && !cs_r && !cs_l) {
    if(c_past != 'd') {
      $('#gamepad .material .crs_d').clone(true).prependTo('#gamepad .active');
      c_past = 'd';
    }
  }
  if(cs_d && cs_r && !cs_l) {
    if(c_past != 'rd') {
      $('#gamepad .material .crs_rd').clone(true).prependTo('#gamepad .active');
      c_past = 'rd';
    }
  }
  if(cs_d && !cs_r && cs_l) {
    if(c_past != 'ld') {
      $('#gamepad .material .crs_ld').clone(true).prependTo('#gamepad .active');
      c_past = 'ld';
    }
  }

  if(cs_l && !cs_u && !cs_d) {
    if(c_past != 'l') {
      $('#gamepad .material .crs_l').clone(true).prependTo('#gamepad .active');
      c_past = 'l';
    }
  }



  // 左スティック左右
  var btn_rs_lr = gp.axes[0];
  //右スティック対応
  //if (btn_rs_lr <= 0.1 && btn_rs_lr >= -0.1) {
  //  btn_rs_lr = gp.axes[2];
  //}
  if (btn_rs_lr > 0.1) {
    scs_r = true;
    scs_l = false;
  } else if (btn_rs_lr < -0.1) {
    scs_l = true;
    scs_r = false;
  } else {
    scs_r = false;
    scs_l = false;
  }
  // 左スティック上下
  var btn_rs_ud = gp.axes[1];
  //右スティック対応
  //if (btn_rs_ud <= 0.1 && btn_rs_ud >= -0.1) {
  //  btn_rs_ud = gp.axes[3];
  //}
  if (btn_rs_ud > 0.1) {
    scs_d = true;
    scs_u = false;
  } else if (btn_rs_ud < -0.1) {
    scs_u = true;
    scs_d = false;
  } else {
    scs_u = false;
    scs_d = false;
  }


  if(!scs_u && !scs_r && !scs_d && !scs_l) {
    s_past = '';
  }

  if(scs_u && !scs_r && !scs_l) {
    if(s_past != 'u') {
      $('#gamepad .material .crs_u').clone(true).prependTo('#gamepad .active');
      s_past = 'u';
    }
  }
  if(scs_u && scs_r && !scs_l) {
    if(s_past != 'ru') {
      $('#gamepad .material .crs_ru').clone(true).prependTo('#gamepad .active');
      s_past = 'ru';
    }
  }
  if(scs_u && !scs_r && scs_l) {
    if(s_past != 'lu') {
      $('#gamepad .material .crs_lu').clone(true).prependTo('#gamepad .active');
      s_past = 'lu';
    }
  }

  if(scs_r && !scs_u && !scs_d) {
    if(s_past != 'r') {
      $('#gamepad .material .crs_r').clone(true).prependTo('#gamepad .active');
      s_past = 'r';
    }
  }

  if(scs_d && !scs_r && !scs_l) {
    if(s_past != 'd') {
      $('#gamepad .material .crs_d').clone(true).prependTo('#gamepad .active');
      s_past = 'd';
    }
  }
  if(scs_d && scs_r && !scs_l) {
    if(s_past != 'rd') {
      $('#gamepad .material .crs_rd').clone(true).prependTo('#gamepad .active');
      s_past = 'rd';
    }
  }
  if(scs_d && !scs_r && scs_l) {
    if(s_past != 'ld') {
      $('#gamepad .material .crs_ld').clone(true).prependTo('#gamepad .active');
      s_past = 'ld';
    }
  }

  if(scs_l && !scs_u && !scs_d) {
    if(s_past != 'l') {
      $('#gamepad .material .crs_l').clone(true).prependTo('#gamepad .active');
      s_past = 'l';
    }
  }


  // 方向プッシュ中かどうか
  if(!cs_u&&!cs_r&&!cs_d&&!cs_l&&!scs_u&&!scs_r&&!scs_d&&!scs_l){
    pushed_arr = false;
    on_count = 0;
    loopCount = 0;
  } else {
    loopCount++;
    if(loopCount<dj){
      pushed_arr = true;
    } else {
      on_count = 999;
      pushed_arr = false;
    }
  }


  function createBlank(){
    if(!cs_u && !cs_d && !cs_l && !cs_r && !scs_u && !scs_d && !scs_l && !scs_r) {
      if(on_count ==0){
        $('#gamepad .material .blank').clone(true).prependTo('#gamepad .active');
        c_past = '';
        s_past = '';
      }
    }
  }


  // clear on_count
  if(loopCount > dj){
    on_count = 0;
  }


  // A
  if (btnPressed(gp.buttons[0])) {
    loopCount++;
    if(enb_a) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_a .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_a .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_a = false;
  } else {
    if(!pushed_arr){
      enb_a = true;
    }
  }
  // B
  if (btnPressed(gp.buttons[1])) {
    if(enb_b) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_b .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_b .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_b = false;
  } else {
    if(!pushed_arr){
      enb_b = true;
    }
  }
  // X
  if (btnPressed(gp.buttons[2])) {
    if(enb_x) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_x .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_x .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_x = false;
  } else {
    if(!pushed_arr){
      enb_x = true;
    }
  }
  // Y
  if (btnPressed(gp.buttons[3])) {
    if(enb_y) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_y .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_y .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_y = false;
  } else {
    if(!pushed_arr){
      enb_y = true;
    }
  }

  // LB
  if (btnPressed(gp.buttons[4])) {
    if(enb_lb) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_lb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_lb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_lb = false;
  } else {
    if(!pushed_arr){
      enb_lb = true;
    }
  }
  // LT
  if (btnPressed(gp.buttons[6])) {
    if(enb_lt) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_lt .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_lt .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_lt = false;
  } else {
    if(!pushed_arr){
      enb_lt = true;
    }
  }
  // RB
  if (btnPressed(gp.buttons[5])) {
    if(enb_rb) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_rb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_rb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_rb = false;
  } else {
    if(!pushed_arr){
      enb_rb = true;
    }
  }
  // RT
  if (btnPressed(gp.buttons[7])) {
    if(enb_rt) {
      if(on_count < 1){
        createBlank();
      }
      if(on_count < 4){
        $('#gamepad .material .btn_rt .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      if(loopCount > dj){
        c_past = '';
        s_past = '';
        $('#gamepad .material .btn_rt .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
      }
      on_count++;
    }
    enb_rt = false;
  } else {
    if(!pushed_arr){
      enb_rt = true;
    }
  }


  if(!fighting) {

    // LSB
    if (btnPressed(gp.buttons[8])) {
      if(enb_lsb) {
        if(on_count < 1){
          createBlank();
        }
        if(on_count < 4){
          $('#gamepad .material .btn_lsb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
        }
        if(loopCount > dj){
          c_past = '';
          s_past = '';
          $('#gamepad .material .btn_lsb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
        }
        on_count++;
      }
      enb_lsb = false;
    } else {
      if(!pushed_arr){
        enb_lsb = true;
      }
    }
    // RSB
    if (btnPressed(gp.buttons[9])) {
      if(enb_rsb) {
        if(on_count < 1){
          createBlank();
        }
        if(on_count < 4){
          $('#gamepad .material .btn_rsb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
        }
        if(loopCount > dj){
          c_past = '';
          s_past = '';
          $('#gamepad .material .btn_rsb .inn').clone(true).addClass('cnt_'+on_count).prependTo('#gamepad .active .wrap:eq(0)');
        }
        on_count++;
      }
      enb_rsb = false;
    } else {
      if(!pushed_arr){
        enb_rsb = true;
      }
    }

  }
  // not fighting




  start = requestAnimationFrame(padMonitor);
};



window.addEventListener("gamepadconnected", (e) => {

  if($('#gamepad')[0]){
    $('#gamepad').removeClass('sleep');
  }
  if($('#gamepad .sleepin')[0]){
    $('#gamepad .sleepin').fadeOut(300);
  }

  padMonitor();


  console.log(
    "Gamepad connected at index %d: %s. %d buttons, %d axes.",
    e.gamepad.index,
    e.gamepad.id,
    e.gamepad.buttons.length,
    e.gamepad.axes.length
  );

  
});


